use axum::{extract::State, response::Html, routing::post, Form, Router};
use tera::Context;

use crate::db;

pub fn app() -> axum::Router<crate::Context> {
    Router::new().route("/", post(post_event))
}

async fn post_event(
    State(ctx): State<crate::Context>,
    Form(event): Form<db::NewEvent>,
) -> super::Result<Html<String>> {
    let event = tokio::task::spawn_blocking(move || event.insert(&ctx.pool))
        .await
        .unwrap()?;

    let mut context = Context::new();
    context.insert("event", &event);
    Ok(Html(ctx.tera.render("updates/event_li.html", &context)?))
}
